# vim:set fileencoding=utf-8 ft=python ts=8 sw=4 sts=4 et cindent:

# fsmi.fsdeluxe -- Wrap the prfproto database (as needed).
#
# Copyright © 2010  Philipp Kern <pkern@debian.org>
# Copyright © 2010, 2011  Fabian Knittel <fabian.knittel@avona.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.

from __future__ import absolute_import

import sqlalchemy.orm as orm
import sqlalchemy.exc
from garfield.database import reflect_tables
from garfield.database import Database


class Fehlkopie(object):
    """
    | datum
    | id
    | nachaccount
    | seiten
    | vonaccount
    | uebertragen
    @DynamicAttrs
    """
    pass

def setup_tables(_sess, meta):
    tables = reflect_tables(meta, ['fehlkopien'])

    orm.mapper(Fehlkopie, tables['fehlkopien'])


def setup_fsdeluxe_environment(config, _garfield_sess, _garfield_meta,
            environment_sess):
    try:
        fsdeluxe_db = Database()
        fsdeluxe_db.load_config(config, 'fsdeluxe_db')
        fsdeluxe_db.setup()

        setup_tables(fsdeluxe_db.session, fsdeluxe_db.meta)

        environment_sess['fsdeluxe_sess'] = fsdeluxe_db.session
    except sqlalchemy.exc.OperationalError:
        pass
